Index: core/xwiki-observation/xwiki-observation-local/pom.xml
===================================================================
--- core/xwiki-observation/xwiki-observation-local/pom.xml	(revision 28165)
+++ core/xwiki-observation/xwiki-observation-local/pom.xml	(working copy)
@@ -40,6 +40,11 @@
       <artifactId>xwiki-core-component-api</artifactId>
       <version>${pom.version}</version>
     </dependency>
+    <dependency>
+      <groupId>org.xwiki.platform</groupId>
+      <artifactId>xwiki-core-model</artifactId>
+      <version>${pom.version}</version>
+    </dependency>
   </dependencies>
   <build>
     <plugins>
Index: core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/WikiDeletedEvent.java
===================================================================
--- core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/WikiDeletedEvent.java	(revision 0)
+++ core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/WikiDeletedEvent.java	(revision 0)
@@ -0,0 +1,46 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+ */package org.xwiki.observation.event;
+
+import org.xwiki.model.reference.WikiReference;
+
+/**
+ * An event triggered when a wiki is deleted.
+ * 
+ * @version $Id$
+ */
+public class WikiDeletedEvent extends AbstractWikiEvent
+{
+    /**
+     * The version identifier for this Serializable class. Increment only if the <i>serialized</i> form of the class
+     * changes.
+     */
+    private static final long serialVersionUID = 1L;
+
+    public WikiDeletedEvent()
+    {
+
+    }
+
+    public WikiDeletedEvent(WikiReference wikiReference)
+    {
+        super(wikiReference);
+    }
+}
Index: core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/AbstractWikiEvent.java
===================================================================
--- core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/AbstractWikiEvent.java	(revision 0)
+++ core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/AbstractWikiEvent.java	(revision 0)
@@ -0,0 +1,52 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+ */
+package org.xwiki.observation.event;
+
+import org.xwiki.model.reference.WikiReference;
+
+/**
+ * Wikis related events.
+ * 
+ * @version $Id$
+ */
+public abstract class AbstractWikiEvent extends AbstractEntityEvent
+{
+    /**
+     * The version identifier for this Serializable class. Increment only if the <i>serialized</i> form of the class
+     * changes.
+     */
+    private static final long serialVersionUID = 1L;
+
+    public AbstractWikiEvent()
+    {
+
+    }
+
+    public AbstractWikiEvent(WikiReference wikiReference)
+    {
+        super(wikiReference);
+    }
+
+    public WikiReference getWikiReference()
+    {
+        return (WikiReference) getEntityReference();
+    }
+}
Index: core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/WikiCreatedEvent.java
===================================================================
--- core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/WikiCreatedEvent.java	(revision 0)
+++ core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/WikiCreatedEvent.java	(revision 0)
@@ -0,0 +1,47 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+ */
+package org.xwiki.observation.event;
+
+import org.xwiki.model.reference.WikiReference;
+
+/**
+ * An event triggered when a new wiki created.
+ * 
+ * @version $Id$
+ */
+public class WikiCreatedEvent extends AbstractWikiEvent
+{
+    /**
+     * The version identifier for this Serializable class. Increment only if the <i>serialized</i> form of the class
+     * changes.
+     */
+    private static final long serialVersionUID = 1L;
+
+    public WikiCreatedEvent()
+    {
+
+    }
+
+    public WikiCreatedEvent(WikiReference wikiReference)
+    {
+        super(wikiReference);
+    }
+}
Index: core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/AbstractEntityEvent.java
===================================================================
--- core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/AbstractEntityEvent.java	(revision 0)
+++ core/xwiki-observation/xwiki-observation-local/src/main/java/org/xwiki/observation/event/AbstractEntityEvent.java	(revision 0)
@@ -0,0 +1,86 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+ */
+package org.xwiki.observation.event;
+
+import java.io.Serializable;
+
+import org.xwiki.model.reference.EntityReference;
+import org.xwiki.model.reference.WikiReference;
+
+/**
+ * Model entities related events.
+ * 
+ * @version $Id$
+ */
+public abstract class AbstractEntityEvent implements Event, Serializable
+{
+    /**
+     * The version identifier for this Serializable class. Increment only if the <i>serialized</i> form of the class
+     * changes.
+     */
+    private static final long serialVersionUID = 1L;
+
+    private EntityReference entityReference;
+
+    /**
+     * Match any entity event.
+     */
+    public AbstractEntityEvent()
+    {
+
+    }
+
+    /**
+     * Match an entity equals to the specified entity.
+     * 
+     * @param entityReference entity reference associated to the event
+     */
+    public AbstractEntityEvent(WikiReference entityReference)
+    {
+        this.entityReference = entityReference;
+    }
+
+    /**
+     * @return
+     */
+    public EntityReference getEntityReference()
+    {
+        return this.entityReference;
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see org.xwiki.observation.event.Event#matches(java.lang.Object)
+     */
+    public boolean matches(Object otherEvent)
+    {
+        boolean isMatching = false;
+
+        if (this.getClass().isAssignableFrom(otherEvent.getClass())) {
+            isMatching =
+                getEntityReference() == null
+                    || getEntityReference().equals(((AbstractEntityEvent) otherEvent).getEntityReference());
+        }
+
+        return isMatching;
+    }
+}