Index: src/test/resources/macros/macro1.test
===================================================================
--- src/test/resources/macros/macro1.test	(revision 27512)
+++ src/test/resources/macros/macro1.test	(arbetskopia)
@@ -13,36 +13,40 @@
 .expect|event/1.0
 .#-----------------------------------------------------
 beginDocument
-onMacroStandalone [testsimplemacro] []
-onMacroStandalone [testsimplemacro] [param1=value1|param2=value2]
-onMacroStandalone [testsimplemacro] [param1=value1|param2=value2] [content]
-onMacroStandalone [testsimplemacro] [] [content]
+beginParagraph
+onMacroInline [testsimplemacro] []
+onNewLine
+onMacroInline [testsimplemacro] [param1=value1|param2=value2]
+onNewLine
+onMacroInline [testsimplemacro] [param1=value1|param2=value2] [content]
+onNewLine
+onMacroInline [testsimplemacro] [] [content]
+endParagraph
 endDocument
 .#-----------------------------------------------------
 .expect|xhtml/1.0
 .#-----------------------------------------------------
+<p><br/><br/><br/></p>
 .#-----------------------------------------------------
 .expect|annotatedxhtml/1.0
 .#-----------------------------------------------------
-<!--startmacro:testsimplemacro|-|--><!--stopmacro--><!--startmacro:testsimplemacro|-|param1="value1" param2="value2"--><!--stopmacro--><!--startmacro:testsimplemacro|-|param1="value1" param2="value2"|-|content--><!--stopmacro--><!--startmacro:testsimplemacro|-||-|content--><!--stopmacro-->
+<p><!--startmacro:testsimplemacro|-|--><!--stopmacro--><br/><!--startmacro:testsimplemacro|-|param1="value1" param2="value2"--><!--stopmacro--><br/><!--startmacro:testsimplemacro|-|param1="value1" param2="value2"|-|content--><!--stopmacro--><br/><!--startmacro:testsimplemacro|-||-|content--><!--stopmacro--></p>
 .#-----------------------------------------------------
 .expect|xwiki/2.0
 .#-----------------------------------------------------
 {{testsimplemacro/}}
-
 {{testsimplemacro param1="value1" param2="value2"/}}
-
-{{testsimplemacro param1="value1" param2="value2"}}
-content
-{{/testsimplemacro}}
-
-{{testsimplemacro}}
-content
-{{/testsimplemacro}}
+{{testsimplemacro param1="value1" param2="value2"}}content{{/testsimplemacro}}
+{{testsimplemacro}}content{{/testsimplemacro}}
 .#-----------------------------------------------------
 .input|xhtml/1.0
 .#-----------------------------------------------------
-<!--startmacro:testsimplemacro|-|--><!--stopmacro--><!--startmacro:testsimplemacro|-|param1="value1" param2="value2"--><!--stopmacro--><!--startmacro:testsimplemacro|-|param1="value1" param2="value2"|-|content--><!--stopmacro--><!--startmacro:testsimplemacro|-||-|content--><!--stopmacro-->
+<p><!--startmacro:testsimplemacro|-|--><!--stopmacro--><br/><!--startmacro:testsimplemacro|-|param1="value1" param2="value2"--><!--stopmacro--><br/><!--startmacro:testsimplemacro|-|param1="value1" param2="value2"|-|content--><!--stopmacro--><br/><!--startmacro:testsimplemacro|-||-|content--><!--stopmacro--></p>
 .#-----------------------------------------------------
 .expect|plain/1.0
+.#-----------------------------------------------------
+
+
+
+
 .#-----------------------------------------------------
\ No newline at end of file
Index: src/test/resources/macros/macro2.test
===================================================================
--- src/test/resources/macros/macro2.test	(revision 27512)
+++ src/test/resources/macros/macro2.test	(arbetskopia)
@@ -8,12 +8,14 @@
 .expect|event/1.0
 .#-----------------------------------------------------
 beginDocument
-onMacroStandalone [macro] []
-onMacroStandalone [macro] []
+beginParagraph
+onMacroInline [macro] []
+onNewLine
+onMacroInline [macro] []
+endParagraph
 endDocument
 .#-----------------------------------------------------
 .expect|xwiki/2.0
 .#-----------------------------------------------------
 {{macro/}}
-
 {{macro/}}
\ No newline at end of file
Index: src/test/resources/escape/escape16.test
===================================================================
--- src/test/resources/escape/escape16.test	(revision 27512)
+++ src/test/resources/escape/escape16.test	(arbetskopia)
@@ -9,8 +9,9 @@
 .expect|event/1.0
 .#-----------------------------------------------------
 beginDocument
-onMacroStandalone [macro] [] [--]
 beginParagraph
+onMacroInline [macro] [] [--]
+onNewLine
 beginLink [Reference = [reference]] [false]
 onSpecialSymbol [-]
 onSpecialSymbol [-]
@@ -22,17 +23,14 @@
 .#-----------------------------------------------------
 .expect|xhtml/1.0
 .#-----------------------------------------------------
-<p><span class="wikiexternallink"><a href="reference">--</a></span><br/><img src="--" class="wikimodel-freestanding" alt="--"/></p>
+<p><br/><span class="wikiexternallink"><a href="reference">--</a></span><br/><img src="--" class="wikimodel-freestanding" alt="--"/></p>
 .#-----------------------------------------------------
 .expect|xwiki/2.0
 .#-----------------------------------------------------
-{{macro}}
---
-{{/macro}}
-
+{{macro}}--{{/macro}}
 [[~~-~~->>reference]]
 image:--
 .#-----------------------------------------------------
 .input|xhtml/1.0
 .#-----------------------------------------------------
-<!--startmacro:macro|-||-|-\-\--><!--stopmacro--><p><!--startwikilink:reference--><span class="wikiexternallink"><a href="reference">--</a></span><!--stopwikilink--><br/><!--startimage:-\-\--><img src="--" class="wikimodel-freestanding" alt="--"/><!--stopimage--></p>
\ No newline at end of file
+<p><!--startmacro:macro|-||-|-\-\--><!--stopmacro--><br/><!--startwikilink:reference--><span class="wikiexternallink"><a href="reference">--</a></span><!--stopwikilink--><br/><!--startimage:-\-\--><img src="--" class="wikimodel-freestanding" alt="--"/><!--stopimage--></p>
\ No newline at end of file
Index: src/test/resources/verbatim/verbatim8.test
===================================================================
--- src/test/resources/verbatim/verbatim8.test	(revision 27512)
+++ src/test/resources/verbatim/verbatim8.test	(arbetskopia)
@@ -10,29 +10,31 @@
 .expect|event/1.0
 .#-----------------------------------------------------
 beginDocument
-onVerbatim [ ~ ] [false]
-onVerbatim [ }}} ] [false]
-onVerbatim [ }}} }}}] [false]
-onVerbatim [ {{{ ] [false]
-onVerbatim [ {{{ {{{{ ] [false]
+beginParagraph
+onVerbatim [ ~ ] [true]
+onNewLine
+onVerbatim [ }}} ] [true]
+onNewLine
+onVerbatim [ }}} }}}] [true]
+onNewLine
+onVerbatim [ {{{ ] [true]
+onNewLine
+onVerbatim [ {{{ {{{{ ] [true]
+endParagraph
 endDocument
 .#-----------------------------------------------------
 .expect|xhtml/1.0
 .#-----------------------------------------------------
-<pre> ~ </pre><pre> }}} </pre><pre> }}} }}}</pre><pre> {{{ </pre><pre> {{{ {{{{ </pre>
+<p><tt class="wikimodel-verbatim"> ~ </tt><br/><tt class="wikimodel-verbatim"> }}} </tt><br/><tt class="wikimodel-verbatim"> }}} }}}</tt><br/><tt class="wikimodel-verbatim"> {{{ </tt><br/><tt class="wikimodel-verbatim"> {{{ {{{{ </tt></p>
 .#-----------------------------------------------------
 .expect|xwiki/2.0
 .#-----------------------------------------------------
 {{{ ~ }}}
-
 {{{ ~}}} }}}
-
 {{{ ~}}} ~}~}~}}}}
-
 {{{ ~{{{ }}}
-
 {{{ ~{{{ ~{~{~{{ }}}
 .#-----------------------------------------------------
 .input|xhtml/1.0
 .#-----------------------------------------------------
-<pre> ~ </pre><pre> }}} </pre><pre> }}} }}}</pre><pre> {{{ </pre><pre> {{{ {{{{ </pre>
\ No newline at end of file
+<p><tt class="wikimodel-verbatim"> ~ </tt><br/><tt class="wikimodel-verbatim"> }}} </tt><br/><tt class="wikimodel-verbatim"> }}} }}}</tt><br/><tt class="wikimodel-verbatim"> {{{ </tt><br/><tt class="wikimodel-verbatim"> {{{ {{{{ </tt></p>