Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-script/src/test/resources/macroscript3.test
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-script/src/test/resources/macroscript3.test	(revision 29059)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-script/src/test/resources/macroscript3.test	(working copy)
@@ -8,7 +8,8 @@
 {{/script}}
 {{/script}}
 .#-----------------------------------------------------
-.expect|event/1.0
+.# Skipped, since nested scripts are not allowed any more, but it is hard to match the error trace here
+.expect|event/1.0|skip
 .#-----------------------------------------------------
 beginDocument
 beginMacroMarkerStandalone [script] [] [{{script}}
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-script/src/test/resources/macroscript5.test
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-script/src/test/resources/macroscript5.test	(revision 29059)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-script/src/test/resources/macroscript5.test	(working copy)
@@ -4,7 +4,8 @@
 .#-----------------------------------------------------
 text {{script}}{{script}}script here{{/script}}{{/script}} text
 .#-----------------------------------------------------
-.expect|event/1.0
+.# Skipped, since nested scripts are not allowed any more, but it is hard to match the error trace here
+.expect|event/1.0|skip
 .#-----------------------------------------------------
 beginDocument
 beginParagraph
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-script/src/main/java/org/xwiki/rendering/macro/script/AbstractScriptMacro.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-script/src/main/java/org/xwiki/rendering/macro/script/AbstractScriptMacro.java	(revision 29059)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-script/src/main/java/org/xwiki/rendering/macro/script/AbstractScriptMacro.java	(working copy)
@@ -20,7 +20,6 @@
 package org.xwiki.rendering.macro.script;
 
 import java.io.StringReader;
-import java.net.URLClassLoader;
 import java.util.Collections;
 import java.util.List;
 
@@ -33,7 +32,7 @@
 import org.xwiki.context.Execution;
 import org.xwiki.rendering.block.Block;
 import org.xwiki.rendering.block.MacroBlock;
-import org.xwiki.rendering.block.XDOM;
+import org.xwiki.rendering.block.MacroMarkerBlock;
 import org.xwiki.rendering.internal.macro.script.AttachmentClassLoaderFactory;
 import org.xwiki.rendering.macro.AbstractMacro;
 import org.xwiki.rendering.macro.MacroExecutionException;
@@ -196,6 +195,13 @@
             try {
                 Thread.currentThread().setContextClassLoader(newClassLoader);
 
+                // 0) Mark this block as script; abort, if the script is nested
+                MacroBlock currentBlock = context.getCurrentMacroBlock();
+                currentBlock.setIsScript(true);
+                if (isScriptNested(currentBlock)) {
+                    throw new MacroExecutionException("Nested scripts are not allowed");
+                }
+
                 // 1) Run script engine on macro block content
                 String scriptResult = evaluate(parameters, content, context);
 
@@ -213,6 +219,28 @@
     }
 
     /**
+     * Check if this script macro is nested inside another script macro.
+     * 
+     * @param currentBlock the block corresponding to this macro
+     * @return true if the script macro is nested
+     */
+    private boolean isScriptNested(MacroBlock currentBlock)
+    {
+        // traverse the XDOM tree up to the root
+        MacroMarkerBlock parent = currentBlock.getParentBlockByType(MacroMarkerBlock.class);
+        while (parent != null) {
+            if (parent.isScriptingMacro()) {
+                return true;
+            } else if (parent.getId().equals("include")) {
+                // included documents intercept the chain of nested script macros with XWiki syntax
+                return false;
+            }
+            parent = parent.getParentBlockByType(MacroMarkerBlock.class);
+        }
+        return false;
+    }
+
+    /**
      * @param jarsParameterValue the value of the macro parameters used to pass extra URLs that should be in the
      *            execution class loader
      * @param parent the parent classloader for the classloader to create (if it doesn't already exist)
@@ -238,7 +266,7 @@
      * @return the class loader to use for executing the script
      * @throws Exception in case of an error in building the class loader
      */
-    private URLClassLoader findClassLoader(String jarsParameterValue, ClassLoader parent) throws Exception
+    private ClassLoader findClassLoader(String jarsParameterValue, ClassLoader parent) throws Exception
     {
         // We cache the Class Loader for improved performances and we check if the saved class loader had the same
         // jar parameters value as the current execution. If not, we compute a new class loader.
@@ -308,7 +336,7 @@
         List<Block> result;
 
         if (parameters.isWiki()) {
-            XDOM parsedDom = parseSourceSyntax(content, context);
+            Block parsedDom = parseSourceSyntax(content, context);
 
             // 3) If in inline mode remove any top level paragraph
             result = parsedDom.getChildren();
@@ -373,7 +401,7 @@
      * @return an XDOM containing the parser content.
      * @throws MacroExecutionException failed to parse content
      */
-    protected XDOM parseSourceSyntax(String content, MacroTransformationContext context) throws MacroExecutionException
+    protected Block parseSourceSyntax(String content, MacroTransformationContext context) throws MacroExecutionException
     {
         Parser parser = getSyntaxParser(context);
 
Index: core/xwiki-rendering/xwiki-rendering-api/src/main/java/org/xwiki/rendering/block/MacroBlock.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-api/src/main/java/org/xwiki/rendering/block/MacroBlock.java	(revision 29059)
+++ core/xwiki-rendering/xwiki-rendering-api/src/main/java/org/xwiki/rendering/block/MacroBlock.java	(working copy)
@@ -51,6 +51,11 @@
     private boolean isInline;
 
     /**
+     * Distinguishes between script macros (Velocity, Groovy) and the rest. False by default.
+     */
+    private boolean isScript;
+
+    /**
      * @param id the id of the macro
      * @param parameters the parameters of the macro
      * @param isInline indicate if the macro is located in a inline content (like paragraph, etc.)
@@ -73,6 +78,7 @@
         this.id = id;
         this.content = content;
         this.isInline = isInline;
+        this.isScript = false;
     }
 
     /**
@@ -122,4 +128,22 @@
         // process is executed. This does get called during our unit tests though.
         listener.onMacro(getId(), getParameters(), getContent(), isInline());
     }
+
+    /**
+     * Set this property to true if this macro is a script.
+     * 
+     * @param isScript the value to set
+     */
+    public void setIsScript(boolean isScript)
+    {
+        this.isScript = isScript;
+    }
+
+    /**
+     * @return true if this macro is a script
+     */
+    public boolean isScript()
+    {
+        return this.isScript;
+    }
 }
Index: core/xwiki-rendering/xwiki-rendering-api/src/main/java/org/xwiki/rendering/block/MacroMarkerBlock.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-api/src/main/java/org/xwiki/rendering/block/MacroMarkerBlock.java	(revision 29059)
+++ core/xwiki-rendering/xwiki-rendering-api/src/main/java/org/xwiki/rendering/block/MacroMarkerBlock.java	(working copy)
@@ -50,6 +50,11 @@
     private boolean isInline;
 
     /**
+     * If true, this marker replaced a script (velocity, groovy etc.). Set to false by default.
+     */
+    private boolean isScriptingMacro;
+
+    /**
      * @param id the name of the macro
      * @param parameters the parameters of the macro
      * @param childBlocks the list of children blocks generated by the macro
@@ -75,6 +80,7 @@
         this.id = id;
         this.content = content;
         this.isInline = isInline;
+        this.isScriptingMacro = false;
     }
 
     /**
@@ -131,4 +137,22 @@
     {
         listener.endMacroMarker(getName(), getParameters(), getContent(), isInline());
     }
+
+    /**
+     * Set this property to true if this marker block replaced a script block.
+     * 
+     * @param isScriptingMacro the value to set
+     */
+    public void setIsScriptingMacro(boolean isScriptingMacro)
+    {
+        this.isScriptingMacro = isScriptingMacro;
+    }
+
+    /**
+     * @return true if this marker block replaced a script block
+     */
+    public boolean isScriptingMacro()
+    {
+        return this.isScriptingMacro;
+    }
 }
Index: core/xwiki-rendering/xwiki-rendering-api/src/main/java/org/xwiki/rendering/internal/transformation/MacroTransformation.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-api/src/main/java/org/xwiki/rendering/internal/transformation/MacroTransformation.java	(revision 29059)
+++ core/xwiki-rendering/xwiki-rendering-api/src/main/java/org/xwiki/rendering/internal/transformation/MacroTransformation.java	(working copy)
@@ -240,10 +240,19 @@
         return macroHolders.size() > 0 ? macroHolders.get(0) : null;
     }
 
+    /**
+     * Wrap the output of a macro block with a {@link MacroMarkerBlock}.
+     * 
+     * @param macroBlockToWrap the block that should be replaced
+     * @param newBlocks list of blocks to wrap
+     * @return the wrapper
+     */
     private Block wrapInMacroMarker(MacroBlock macroBlockToWrap, List<Block> newBlocks)
     {
-        return new MacroMarkerBlock(macroBlockToWrap.getId(), macroBlockToWrap.getParameters(), macroBlockToWrap
-            .getContent(), newBlocks, macroBlockToWrap.isInline());
+        MacroMarkerBlock marker = new MacroMarkerBlock(macroBlockToWrap.getId(), macroBlockToWrap.getParameters(),
+            macroBlockToWrap.getContent(), newBlocks, macroBlockToWrap.isInline());
+        marker.setIsScriptingMacro(macroBlockToWrap.isScript());
+        return marker;
     }
 
     private void generateError(MacroBlock macroToReplace, String message, String description)